/*global
  console:false
  XLAB:false,
  compute_grid_index:false
  compute_uv_coordinates:false
  WebGLRenderingContext:false
  compute_remaining_parts:false
*/
/*
  callback is called like this: callback(surface,arg).
*/
/*
  function load_surface(metadata, callback) {

  F = [];
  for (var i in metadata.files) {
  if (i == 'position_and_normal' || i == 'index' || i == 'texture') {
  F.push(metadata.files[i]);
  }
  }
  XLAB.load_binary_files( F,
  function() {
  return function(bdata, urls) {_create_surface(bdata,urls,metadata,callback); };
  }() );
  }
*/

function load_surface(path, callback) {
    "use strict";
    // load the JSON index file
    XLAB.load_file(
	path + "index.json",
	function(path0,callback0) {
            return function(text) { _load_surface(JSON.parse(text), path, callback); };
	}(path,callback)
    );
}

function _load_surface(metadata, path, callback) {
    "use strict";
    var files;
    if ( "grid" in metadata ) {
	// grid
	files = [path + 'vertex.bin'];
    }
    else {
	// non-grid
	// TODO: put texture data into vertex.bin?
	files = [path + 'vertex.bin', path + 'texture.bin', path + 'face.bin'];
    }
    XLAB.load_binary_files(
	files,
	function() {
            return function(bdata, urls) { _create_surface(bdata,urls,metadata,callback); };
	}() );

}

/*
  function compute_remaining_parts() {
  "use strict";
  for (var i in surfaceMetadata) {
  surfaceMetadata[i].remaining_parts = _compute_remaining_parts1(surfaceMetadata[i]);
  }
  }
*/

/**
   Creates a surface from metadata and binary data.
*/
function _create_surface(bdata, urls, metadata, callback) {
    "use strict";

    metadata.remaining_parts = compute_remaining_parts(metadata);

    var position_and_normal;
    var texture;
    var color;
    var index;
    var surface;

    if ('grid' in metadata)
    {
	position_and_normal = bdata[0];
	//color = bdata[1];

	index = compute_grid_index(metadata.grid);

	// uv-coordinates
	texture = compute_uv_coordinates(metadata.grid);

	// triangle count
	var grid = metadata.grid;
	metadata.triangle_count = (grid[0]-1)*(grid[1]-1)*2;

	// create surface
	surface = new XLAB.Surface(
            metadata,
            // position and normal
            position_and_normal,
            // texture
            texture,
            // color
            color,
            // index
            index,
            WebGLRenderingContext.TRIANGLE_STRIP
        );
    }
    else
    {
	position_and_normal = bdata[0];
	texture = bdata[1];
	index = bdata[2];
	//color = bdata[3];

	// triangle count
	//metadata.triangle_count = index.size() / 3;
	var BYTES_PER_ELEMENT = 4;
	metadata.triangle_count = index.byteLength/BYTES_PER_ELEMENT/3;

	surface = new XLAB.Surface(
            metadata,
            // position and normal
            position_and_normal,
            // texture
            texture,
            // color
            color,
            // index
            index,
            WebGLRenderingContext.TRIANGLES);
    }

    callback(surface);
}
