/*global
  global:false
  console:false
  Surface:false
  surfaceMetadata:false
  Float32Array:false
  Uint16Array:false
  XLAB:false
  WebGLRenderingContext:false
*/

// generates indices for GL_TRIANGLES (not used)
function compute_grid_index_triangles( grid ) {
    // TODO: use array
    "use strict";
    var x = grid[0];
    var y = grid[1];
    var X = [];
    for (var j = 0; j < y-1; ++j) {
        for (var i = 0; i < x-1; ++i) {
            X.push(
                // first triangle
                (i)+(j)*x, (i+1)+(j)*x, (i+1)+(j+1)*x,
                // second triangle
                (i+1)+(j+1)*x, (i)+(j+1)*x, (i)+(j)*x );
        }
    }
    return new Uint16Array(X);
}

// generates indices for GL_TRIANGLE_STRIPS
function compute_grid_index( grid ) {
    "use strict";
    var x = grid[0];
    var y = grid[1];
    var X = [];
    // left to right
    for (var i = 0; i < x-1; ++i) {
        // first point
        if (i !== 0) {
            X.push( (i) + (0)*x );
        }
        // bottom to top
        for (var j = 0; j < y; ++j) {
            X.push( (i)+(j)*x, (i+1)+(j)*x );
        }
        // last point for column
        if (i != x-2) {
            X.push( (i+1) + (y-1)*x );
        }
    }
    return new Uint16Array(X);
}

function compute_uv_coordinates(grid) {
    "use strict";
    var x = grid[0];
    var y = grid[1];

    // precompute u coordinate
    var U = [];
    for (var i = 0; i < x; ++i) {
        U[i] = (1.0*i)/(1.0*(x-1));
    }

    var T = [];
    for (var j = 0; j < y; ++j) {
        var v = (1.0*j)/(1.0*(y-1));
        for (var ix = 0; ix < x; ++ix) {
            T.push(U[ix]);
            T.push(v);
        }
    }
    return new Float32Array(T);
}



function _compute_remaining_parts0(p, n) {
    "use strict";
    var q = [];
    for (var i = 0; i < n; ++i) {
        if (p.indexOf(i) == -1) {
            q.push(i);
        }
    }
    return q;
}
function compute_remaining_parts(d) {
    "use strict";
    if ( ! d.parts ) { return null; }
    var n = d.transform.length;
    var P = [];
    for (var p in d.parts) {
        P.push( _compute_remaining_parts0(d.parts[p], n) );
    }
    return P;
}
