/*global
  document:false
*/

function sign(x) {
    "use strict";
    return x > 0 ? 1 : ( x < 0 ? -1 : 0);
}
function clamp( x, min, max ) {
    "use strict";
    if (x < min) { return min; }
    if (x > max) { return max; }
    return x;
}
function parse_int( x ) {
    "use strict";
    return parseInt(x, 10);
}


function get_time() {
    "use strict";
    var date = new Date();
    return date.getTime();
}

function clone(obj){
    "use strict";
    if(obj === null || typeof(obj) != 'object')
	return obj;

    var temp = new obj.constructor();
    for(var key in obj)
	temp[key] = clone(obj[key]);

    return temp;
}

function show(x) {
    "use strict";
    x.style.display = 'block';
    //x.style.visibility = 'visible';
}
function hide(x) {
    "use strict";
    x.style.display = 'none';
    //x.style.visibility = 'hidden';
}

function set_visible(element, state) {
    "use strict";
    //element.style.visibility = state ? 'visible' : 'hidden';
    element.style.display = state ? 'block' : 'none';
}
function set_element_visible(id, state) {
    "use strict";
    document.getElementById(id).style.visibility = state ? 'visible' : 'hidden';
}

function disableSelection(target)
{
    "use strict";
    target.style.webkitUserSelect = "none";
    target.style.MozUserSelect = "none";
    target.style.mozUserSelect = "none";
    target.style.userSelect = "none";
    target.style.msUserSelect = "none";
    // does not disable ctrl-a for firefox
}
function message(m) {
    "use strict";
    document.getElementById("message").textContent = m;
}

function format_sci(x) {
    "use strict";
    if (x < 1e3) {
	return x + '';
    }
    if (x < 1e6) {
	return (x/1e3).toPrecision(3) + 'K';
    }
    if (x < 1e9) {
	return (x/1e6).toPrecision(3) + 'M';
    }
    if (x < 1e12) {
	return (x/1e9).toPrecision(3) + 'G';
    }
    return x;
    
}
